diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-test.cc ns-3.44/src/wifi/test/wifi-test.cc
--- ns-3.43/src/wifi/test/wifi-test.cc	2024-10-09 16:41:10.140657000 -0700
+++ ns-3.44/src/wifi/test/wifi-test.cc	2025-03-09 16:55:49.811372800 -0700
@@ -1965,25 +1967,25 @@
   private:
     /**
      * Callback function on STA assoc event
-     * \param context context string
-     * \param bssid the associated AP's bssid
+     * @param context context string
+     * @param bssid the associated AP's bssid
      */
     void AssocCallback(std::string context, Mac48Address bssid);
     /**
      * Turn beacon generation on the AP node
-     * \param apNode the AP node
+     * @param apNode the AP node
      */
     void TurnBeaconGenerationOn(Ptr<Node> apNode);
     /**
      * Turn the AP node off
-     * \param apNode the AP node
+     * @param apNode the AP node
      */
     void TurnApOff(Ptr<Node> apNode);
     /**
      * Setup test
-     * \param nearestApBeaconGeneration set BeaconGeneration attribute of the nearest AP
-     * \param staActiveProbe set ActiveProbing attribute of the STA
-     * \return node container containing all nodes
+     * @param nearestApBeaconGeneration set BeaconGeneration attribute of the nearest AP
+     * @param staActiveProbe set ActiveProbing attribute of the STA
+     * @return node container containing all nodes
      */
     NodeContainer Setup(bool nearestApBeaconGeneration, bool staActiveProbe);
 
@@ -2168,11 +2170,11 @@
   private:
     /**
      * Callback when ADDBA state changed
-     * \param context node context
-     * \param t the time the state changed
-     * \param recipient the MAC address of the recipient
-     * \param tid the TID
-     * \param state the state
+     * @param context node context
+     * @param t the time the state changed
+     * @param recipient the MAC address of the recipient
+     * @param tid the TID
+     * @param state the state
      */
     void AddbaStateChangedCallback(std::string context,
                                    Time t,
@@ -2181,11 +2183,11 @@
                                    OriginatorBlockAckAgreement::State state);
     /**
      * Callback when a frame is transmitted.
-     * \param rxErrorModel the post reception error model on the receiver
-     * \param context the context
-     * \param psduMap the PSDU map
-     * \param txVector the TX vector
-     * \param txPowerW the tx power in Watts
+     * @param rxErrorModel the post reception error model on the receiver
+     * @param context the context
+     * @param psduMap the PSDU map
+     * @param txVector the TX vector
+     * @param txPowerW the tx power in Watts
      */
     void TxCallback(Ptr<ListErrorModel> rxErrorModel,
                     std::string context,
@@ -2195,13 +2197,13 @@
 
     /**
      * Callback when packet is received
-     * \param context node context
-     * \param p the received packet
-     * \param channelFreqMhz the channel frequency in MHz
-     * \param txVector the TX vector
-     * \param aMpdu the A-MPDU info
-     * \param signalNoise the signal noise in dBm
-     * \param staId the STA-ID
+     * @param context node context
+     * @param p the received packet
+     * @param channelFreqMhz the channel frequency in MHz
+     * @param txVector the TX vector
+     * @param aMpdu the A-MPDU info
+     * @param signalNoise the signal noise in dBm
+     * @param staId the STA-ID
      */
     void RxCallback(std::string context,
                     Ptr<const Packet> p,
@@ -2212,23 +2214,23 @@
                     uint16_t staId);
     /**
      * Callback when packet is dropped
-     * \param context node context
-     * \param p the failed packet
-     * \param snr the SNR of the failed packet in linear scale
+     * @param context node context
+     * @param p the failed packet
+     * @param snr the SNR of the failed packet in linear scale
      */
     void RxErrorCallback(std::string context, Ptr<const Packet> p, double snr);
     /**
      * Triggers the arrival of a burst of 1000 Byte-long packets in the source device
-     * \param numPackets number of packets in burst
-     * \param sourceDevice pointer to the source NetDevice
-     * \param destination address of the destination device
+     * @param numPackets number of packets in burst
+     * @param sourceDevice pointer to the source NetDevice
+     * @param destination address of the destination device
      */
     void SendPacketBurst(uint32_t numPackets,
                          Ptr<NetDevice> sourceDevice,
                          Address& destination) const;
     /**
      * Run subtest for this test suite
-     * \param rcvErrorType type of station (STA or AP) to install the post reception error model on
+     * @param rcvErrorType type of station (STA or AP) to install the post reception error model on
      */
     void RunSubtest(TypeOfStation rcvErrorType);
 
@@ -2457,7 +2459,7 @@
                         apDevice.Get(0),
                         staDevice.Get(0)->GetAddress());
 
-    Simulator::Stop(Seconds(1.0));
+    Simulator::Stop(Seconds(1));
     Simulator::Run();
     Simulator::Destroy();
 }
@@ -2574,27 +2576,27 @@
   private:
     /**
      * Run one function
-     * \param useAmpdu flag to indicate whether the test should be run with A-MPDU
+     * @param useAmpdu flag to indicate whether the test should be run with A-MPDU
      */
     void RunOne(bool useAmpdu);
 
     /**
      * Callback when packet is successfully received
-     * \param context node context
-     * \param p the received packet
+     * @param context node context
+     * @param p the received packet
      */
     void RxSuccessCallback(std::string context, Ptr<const Packet> p);
     /**
      * Triggers the arrival of 1000 Byte-long packets in the source device
-     * \param numPackets number of packets in burst
-     * \param sourceDevice pointer to the source NetDevice
-     * \param destination address of the destination device
+     * @param numPackets number of packets in burst
+     * @param sourceDevice pointer to the source NetDevice
+     * @param destination address of the destination device
      */
     void SendPackets(uint8_t numPackets, Ptr<NetDevice> sourceDevice, Address& destination);
     /**
      * Transmit final data failed function
-     * \param context the context
-     * \param address the MAC address
+     * @param context the context
+     * @param address the MAC address
      */
     void TxFinalDataFailedCallback(std::string context, Mac48Address address);
 
@@ -2660,7 +2662,8 @@
     phy.SetChannel(channel.Create());
 
     WifiHelper wifi;
-    wifi.SetStandard(WIFI_STANDARD_80211ac);
+    // use HT standard so that BlockAck agreement is not established in the useAmpdu false case
+    wifi.SetStandard(useAmpdu ? WIFI_STANDARD_80211ac : WIFI_STANDARD_80211n);
     wifi.SetRemoteStationManager("ns3::IdealWifiManager");
 
     WifiMacHelper mac;
@@ -2695,7 +2698,7 @@
 
     Ptr<WaypointMobilityModel> staWaypointMobility =
         DynamicCast<WaypointMobilityModel>(wifiStaNode.Get(0)->GetObject<MobilityModel>());
-    staWaypointMobility->AddWaypoint(Waypoint(Seconds(1.0), Vector(10.0, 0.0, 0.0)));
+    staWaypointMobility->AddWaypoint(Waypoint(Seconds(1), Vector(10.0, 0.0, 0.0)));
     staWaypointMobility->AddWaypoint(Waypoint(Seconds(1.5), Vector(50.0, 0.0, 0.0)));
 
     if (useAmpdu)
@@ -2719,7 +2722,7 @@
 
     // Transmit a second data packet once the station is away from the access point: it should be
     // sent with the same high modulation and be unsuccessfuly received
-    Simulator::Schedule(Seconds(2.0),
+    Simulator::Schedule(Seconds(2),
                         &Issue40TestCase::SendPackets,
                         this,
                         useAmpdu ? 2 : 1,
@@ -2759,7 +2762,7 @@
                         apDevice.Get(0),
                         staDevice.Get(0)->GetAddress());
 
-    Simulator::Stop(Seconds(3.0));
+    Simulator::Stop(Seconds(3));
     Simulator::Run();
 
     NS_TEST_ASSERT_MSG_EQ(m_txCount,
@@ -2768,7 +2771,9 @@
     NS_TEST_ASSERT_MSG_EQ(m_rxCount,
                           (useAmpdu ? 12 : 6),
                           "Incorrect number of successfully received packets");
-    NS_TEST_ASSERT_MSG_EQ(m_txMacFinalDataFailedCount, 1, "Incorrect number of dropped TX packets");
+    NS_TEST_ASSERT_MSG_EQ(m_txMacFinalDataFailedCount,
+                          (useAmpdu ? 2 : 1),
+                          "Incorrect number of dropped TX packets");
 
     Simulator::Destroy();
 }
@@ -2806,10 +2811,10 @@
   private:
     /**
      * Triggers the transmission of a 1000 Byte-long data packet from the source device
-     * \param numPackets number of packets in burst
-     * \param sourceDevice pointer to the source NetDevice
-     * \param destination address of the destination device
-     * \param priority the priority of the packets to send
+     * @param numPackets number of packets in burst
+     * @param sourceDevice pointer to the source NetDevice
+     * @param destination address of the destination device
+     * @param priority the priority of the packets to send
      */
     void SendPackets(uint8_t numPackets,
                      Ptr<NetDevice> sourceDevice,
@@ -2818,10 +2823,10 @@
 
     /**
      * Callback that indicates a PSDU is being transmitted
-     * \param context the context
-     * \param psdus the PSDU map to transmit
-     * \param txVector the TX vector
-     * \param txPowerW the TX power (W)
+     * @param context the context
+     * @param psdus the PSDU map to transmit
+     * @param txVector the TX vector
+     * @param txPowerW the TX power (W)
      */
     void TxCallback(std::string context,
                     WifiConstPsduMap psdus,
@@ -2924,7 +2929,7 @@
                         0);
 
     // Send non best-effort (voice) packet (i.e. priority 6)
-    Simulator::Schedule(Seconds(1.0),
+    Simulator::Schedule(Seconds(1),
                         &Issue169TestCase::SendPackets,
                         this,
                         1,
@@ -2932,7 +2937,7 @@
                         staDevice.Get(0)->GetAddress(),
                         6);
 
-    Simulator::Stop(Seconds(2.0));
+    Simulator::Stop(Seconds(2));
     Simulator::Run();
 
     Simulator::Destroy();
@@ -2963,23 +2968,23 @@
   private:
     /**
      * Change the configured channel width for all nodes
-     * \param channelWidth the channel width
+     * @param channelWidth the channel width
      */
     void ChangeChannelWidth(MHz_u channelWidth);
 
     /**
      * Triggers the transmission of a 1000 Byte-long data packet from the source device
-     * \param sourceDevice pointer to the source NetDevice
-     * \param destination address of the destination device
+     * @param sourceDevice pointer to the source NetDevice
+     * @param destination address of the destination device
      */
     void SendPacket(Ptr<NetDevice> sourceDevice, Address& destination);
 
     /**
      * Callback that indicates a PSDU is being transmitted
-     * \param context the context
-     * \param psduMap the PSDU map to transmit
-     * \param txVector the TX vector
-     * \param txPowerW the TX power (W)
+     * @param context the context
+     * @param psduMap the PSDU map to transmit
+     * @param txVector the TX vector
+     * @param txPowerW the TX power (W)
      */
     void TxCallback(std::string context,
                     WifiConstPsduMap psduMap,
@@ -2988,7 +2993,7 @@
 
     /**
      * Check if the selected WifiMode is correct
-     * \param expectedMode the expected WifiMode
+     * @param expectedMode the expected WifiMode
      */
     void CheckLastSelectedMode(WifiMode expectedMode);
 
@@ -3090,8 +3095,8 @@
     Simulator::Schedule(Seconds(0.5),
                         &IdealRateManagerChannelWidthTest::ChangeChannelWidth,
                         this,
-                        80);
-    Simulator::Schedule(Seconds(1.0),
+                        MHz_u{80});
+    Simulator::Schedule(Seconds(1),
                         &IdealRateManagerChannelWidthTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3106,8 +3111,8 @@
     Simulator::Schedule(Seconds(1.5),
                         &IdealRateManagerChannelWidthTest::ChangeChannelWidth,
                         this,
-                        20);
-    Simulator::Schedule(Seconds(2.0),
+                        MHz_u{20});
+    Simulator::Schedule(Seconds(2),
                         &IdealRateManagerChannelWidthTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3122,8 +3127,8 @@
     Simulator::Schedule(Seconds(2.5),
                         &IdealRateManagerChannelWidthTest::ChangeChannelWidth,
                         this,
-                        40);
-    Simulator::Schedule(Seconds(3.0),
+                        MHz_u{40});
+    Simulator::Schedule(Seconds(3),
                         &IdealRateManagerChannelWidthTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3159,29 +3164,29 @@
   private:
     /**
      * Change the configured MIMO  settings  for AP node
-     * \param antennas the number of active antennas
-     * \param maxStreams the maximum number of allowed spatial streams
+     * @param antennas the number of active antennas
+     * @param maxStreams the maximum number of allowed spatial streams
      */
     void SetApMimoSettings(uint8_t antennas, uint8_t maxStreams);
     /**
      * Change the configured MIMO  settings  for STA node
-     * \param antennas the number of active antennas
-     * \param maxStreams the maximum number of allowed spatial streams
+     * @param antennas the number of active antennas
+     * @param maxStreams the maximum number of allowed spatial streams
      */
     void SetStaMimoSettings(uint8_t antennas, uint8_t maxStreams);
     /**
      * Triggers the transmission of a 1000 Byte-long data packet from the source device
-     * \param sourceDevice pointer to the source NetDevice
-     * \param destination address of the destination device
+     * @param sourceDevice pointer to the source NetDevice
+     * @param destination address of the destination device
      */
     void SendPacket(Ptr<NetDevice> sourceDevice, Address& destination);
 
     /**
      * Callback that indicates a PSDU is being transmitted
-     * \param context the context
-     * \param psdus the PSDU map to transmit
-     * \param txVector the TX vector
-     * \param txPowerW the TX power (W)
+     * @param context the context
+     * @param psdus the PSDU map to transmit
+     * @param txVector the TX vector
+     * @param txPowerW the TX power (W)
      */
     void TxCallback(std::string context,
                     WifiConstPsduMap psdus,
@@ -3190,12 +3195,12 @@
 
     /**
      * Check if the selected WifiMode is correct
-     * \param expectedMode the expected WifiMode
+     * @param expectedMode the expected WifiMode
      */
     void CheckLastSelectedMode(WifiMode expectedMode);
     /**
      * Check if the selected Nss is correct
-     * \param expectedNss the expected Nss
+     * @param expectedNss the expected Nss
      */
     void CheckLastSelectedNss(uint8_t expectedNss);
 
@@ -3322,7 +3327,7 @@
     // RX: 1 antenna
     Simulator::Schedule(Seconds(0.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 1, 1);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(1.0),
+    Simulator::Schedule(Seconds(1),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3345,7 +3350,7 @@
     // RX: 2 antennas, but only supports 1 spatial stream
     Simulator::Schedule(Seconds(1.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 2, 1);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(2.0),
+    Simulator::Schedule(Seconds(2),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3369,7 +3374,7 @@
     // RX: 2 antennas, and supports 2 spatial streams
     Simulator::Schedule(Seconds(2.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 2, 2);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(3.0),
+    Simulator::Schedule(Seconds(3),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3392,7 +3397,7 @@
     // RX: 1 antenna
     Simulator::Schedule(Seconds(3.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 1, 1);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(4.0),
+    Simulator::Schedule(Seconds(4),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3416,7 +3421,7 @@
     // RX: 2 antennas, but only supports 1 spatial stream
     Simulator::Schedule(Seconds(4.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 2, 1);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(5.0),
+    Simulator::Schedule(Seconds(5),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3441,7 +3446,7 @@
     // RX: 2 antennas, and supports 2 spatial streams
     Simulator::Schedule(Seconds(5.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 2, 2);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(6.0),
+    Simulator::Schedule(Seconds(6),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3464,7 +3469,7 @@
     // RX: 1 antenna
     Simulator::Schedule(Seconds(6.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 1, 1);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(7.0),
+    Simulator::Schedule(Seconds(7),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3488,7 +3493,7 @@
     // RX: 2 antennas, but only supports 1 spatial stream
     Simulator::Schedule(Seconds(7.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 2, 1);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(8.0),
+    Simulator::Schedule(Seconds(8),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3513,7 +3518,7 @@
     // RX: 2 antennas, and supports 2 spatial streams
     Simulator::Schedule(Seconds(8.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 2, 2);
     // Send packets (2 times to get one feedback)
-    Simulator::Schedule(Seconds(9.0),
+    Simulator::Schedule(Seconds(9),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3535,7 +3540,7 @@
     // Verify we can go back to initial situation
     Simulator::Schedule(Seconds(9.9), &IdealRateManagerMimoTest::SetApMimoSettings, this, 1, 1);
     Simulator::Schedule(Seconds(9.9), &IdealRateManagerMimoTest::SetStaMimoSettings, this, 1, 1);
-    Simulator::Schedule(Seconds(10.0),
+    Simulator::Schedule(Seconds(10),
                         &IdealRateManagerMimoTest::SendPacket,
                         this,
                         apDevice.Get(0),
@@ -3553,10 +3558,10 @@
 
 //-----------------------------------------------------------------------------
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Data rate verification test for MCSs of different RU sizes
+ * @brief Data rate verification test for MCSs of different RU sizes
  */
 class HeRuMcsDataRateTestCase : public TestCase
 {
@@ -3566,13 +3571,13 @@
   private:
     /**
      * Compare the data rate computed for the provided combination with standard defined one.
-     * \param ruType the RU type
-     * \param mcs the modulation and coding scheme (as a string, e.g. HeMcs0)
-     * \param nss the number of spatial streams
-     * \param guardInterval the guard interval to use
-     * \param expectedDataRate the expected data rate in 100 kbps units (minimum granularity in
+     * @param ruType the RU type
+     * @param mcs the modulation and coding scheme (as a string, e.g. HeMcs0)
+     * @param nss the number of spatial streams
+     * @param guardInterval the guard interval to use
+     * @param expectedDataRate the expected data rate in 100 kbps units (minimum granularity in
      * standard tables)
-     * \returns true if data rates are the same, false otherwise
+     * @returns true if data rates are the same, false otherwise
      */
     bool CheckDataRate(HeRu::RuType ruType,
                        std::string mcs,
@@ -3602,7 +3607,7 @@
                                  1,
                                  1,
                                  0,
-                                 160,
+                                 MHz_u{160},
                                  false,
                                  false);
     WifiMode mode(mcs);
@@ -3665,10 +3670,10 @@
     std::tuple<SupportedRates, std::optional<ExtendedSupportedRatesIE>, std::vector<Ssid>>;
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Test management header
+ * @brief Test management header
  */
 class MgtTestHeader : public WifiMgtHeader<MgtTestHeader, MgtTestElems>
 {
@@ -3677,12 +3682,12 @@
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
 
     /**
-     * \return the TypeId for this object.
+     * @return the TypeId for this object.
      */
     TypeId GetInstanceTypeId() const override;
 
@@ -3708,10 +3713,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Mgt header (de)serialization Test Suite
+ * @brief Mgt header (de)serialization Test Suite
  */
 class WifiMgtHeaderTest : public HeaderSerializationTestCase
 {
@@ -3831,8 +3836,8 @@
 
     /**
      * Trace sink to receive from the PacketSocket; the address parameter is unused
-     * \param context the context
-     * \param p the received packet
+     * @param context the context
+     * @param p the received packet
      */
     void Receive(std::string context, Ptr<const Packet> p, const Address&);
 };
@@ -3957,10 +3962,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Wifi Test Suite
+ * @brief Wifi Test Suite
  */
 class WifiTestSuite : public TestSuite
 {
